unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Tjoystk, CoolTrayIcon;

type
  TForm1 = class(TForm)
    Joystick1: TJoystick;
    Timer1: TTimer;
    Label3: TLabel;
    Image1: TImage;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Button1: TButton;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Bevel3: TBevel;
    Image2: TImage;
    Label7: TLabel;
    CoolTrayIcon1: TCoolTrayIcon;
    Image3: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Image2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure CoolTrayIcon1Click(Sender: TObject);
    procedure nactidata;
    procedure ulozdata;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
const rozdil=336;

var j:integer;
    pole:array [1..3000] of word;
    maxt,mint:real;
    statistika:boolean;
    cekpis,shod,smin:word;
    hodnoty:array [0..287] of real;
    denpoz:word;

function realdotepla(a:real):string;
var b:string;
begin
     str(a:2:1,b);
     if b='-0:0' then b:='0:0';
     b:=b+'C';
     realdotepla:=b;
end;

procedure tform1.nactidata;
var f:textfile;
    rok,den,mesic,rokt,dent,mesict,i:word;
begin
     if fileexists('teplomer.ini') then begin
        assignfile(f,'teplomer.ini');
        reset(f);
        readln(f,rok);
        readln(f,den);
        denpoz:=den;
        readln(f,mesic);
        DecodeDate(Date,rokt,mesict,dent);
        if (rok=rokt) and (den=dent) and (mesic=mesict) then
            for i:=0 to 287 do begin
                                readln(f,hodnoty[i]);
                                if hodnoty[i]<>100 then begin
                                   image2.Picture.Bitmap.Canvas.Pixels[32+i,108-round(2*hodnoty[i])]:=clblue;
                                   if hodnoty[i]>maxt then begin
                                      maxt:=hodnoty[i];
                                      label5.caption:=realdotepla(hodnoty[i]);
                                      end;
                                   if hodnoty[i]<mint then begin
                                      mint:=hodnoty[i];
                                      label6.caption:=realdotepla(hodnoty[i]);
                                      end;
                                end;
                               end;

        closefile(f);
     end;
end;

procedure tform1.ulozdata;
var f:textfile;
    rok,den,mesic,i:word;
begin
        assignfile(f,'teplomer.ini');
        DecodeDate(Date,rok,mesic,den);
        rewrite(f);
        writeln(f,rok);
        writeln(f,den);
        writeln(f,mesic);
        for i:=0 to 287 do writeln(f,hodnoty[i]);
        closefile(f);
end;

procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
begin
     joystick1.activate;
     j:=0;
     form1.Width:=191;
     form1.left:=screen.DesktopWidth-form1.Width+1;
     form1.top:=screen.height-form1.height-28;
     maxt:=-100;
     mint:=100;
     statistika:=false;
     shod:=0;
     smin:=2;
     for i:=0 to 287 do hodnoty[i]:=100;
     nactidata;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var x,hour,min,sec,msec,den,mes,rok:word;
    i:integer;
    y:real;
    star:string;
begin
     inc(j);
     for i:=1 to 999 do pole[i]:=pole[i+1];
     x:=joystick1.JoyInfo.wXpos;
     pole[1000]:=x;
     y:=pole[1];
     label2.caption:=inttostr(j);
     for i:=2 to 1000 do begin
                         y:=y+pole[i];
                         if pole[i]=65535 then label2.caption:='Peteen';
                        end;
     if j<1000 then y:=y/j else begin
                                y:=y/1000;
                                j:=1000;
                               end;

     {zpracovani hodnoty}
     label1.caption:=inttostr(round(y))+' ';
     y:=  -0.0011*x + 41.834;     //zaezi na odporu
     label4.caption:=floattostr(y);
     star:=realdotepla(y);
     if star<>label3.caption then begin
                                   label3.caption:=star;
                                   image1.Picture.Bitmap.Canvas.Pen.Color:=clred;
                                   image1.Picture.Bitmap.Canvas.Rectangle(16,round(108-2*y),18,155);
                                   image1.Picture.Bitmap.Canvas.Pen.Color:=$eeeeee;
                                   image1.Picture.Bitmap.Canvas.Rectangle(16,round(108-2*y)-1,18,5);
                                  end;
     {extremy}
     if (y>maxt) and (j>20) then begin
                                  maxt:=y;
                                  label5.caption:=star;
                                 end;
     if (y<mint) and (j>20) then begin
                                  mint:=y;
                                  label6.caption:=star;
                                 end;

     {zapsani do statistiky}
     DecodeTime(Time,Hour,min,Sec,MSec);
     if not ((shod=hour) and (smin=min)) and ((min mod 5)=0) then begin
                              Decodedate(date,rok,mes,den);
                              if denpoz<>den then begin
                                                   maxt:=-100;
                                                   mint:=100;
                                                   for i:=0 to 287 do hodnoty[i]:=100;
                                                   denpoz:=den;
                                                   image2.Picture.Bitmap:=image3.Picture.Bitmap;
                                                  end;
                              image2.Picture.Bitmap.Canvas.Pixels[32+(hour*12)+round(min/5),108-round(2*y)]:=clblue;
                              shod:=hour; smin:=min;
                              hodnoty[hour*12+round(min/5)]:=y;
                              ulozdata;
                             end;

     {smazani labelu u statistik}
     dec(cekpis);
     if cekpis=0 then label7.caption:='';
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     statistika:=not statistika;
     if statistika then begin
                         form1.width:=191+rozdil;
                         bevel1.left:=128+rozdil;
                         bevel2.Left:=8+rozdil;
                         image1.Left:=128+rozdil;
                         groupbox1.Left:=8+rozdil;
                         groupbox2.Left:=8+rozdil;
                         label3.Left:=16+rozdil;
                         button1.left:=8+rozdil;
                         bevel3.left:=7;
                         image2.left:=8;
                        end else begin
                         bevel1.left:=128;
                         bevel2.Left:=8;
                         image1.Left:=128;
                         groupbox1.Left:=8;
                         groupbox2.Left:=8;
                         label3.Left:=16;
                         button1.left:=8;
                         bevel3.left:=184;
                         image2.left:=184;
                         form1.width:=191;
                        end;
     form1.left:=screen.DesktopWidth-form1.Width+1;
end;

procedure TForm1.Image2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     if (x>31) and (x<320) and (y>7) and (y<148) then begin
        if x<200then label7.Left:=x+20 else label7.left:=x-60;
        label7.top:=y-5;
        if hodnoty[x-32]=100 then label7.caption:='nen v '+inttostr((x-32) div 12)+':'+inttostr(((x-32) mod 12)*5)
           else label7.caption:=realdotepla(hodnoty[x-32])+' v '+inttostr((x-32) div 12)+':'+inttostr(((x-32) mod 12)*5);
        end else label7.caption:='';
     cekpis:=50;
end;

procedure TForm1.CoolTrayIcon1Click(Sender: TObject);
begin
     application.restore;
end;

end.
